#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASUpdateGroup : public CWASCommand
{
public:
	CWASUpdateGroup(CWASActor *pActor);
	~CWASUpdateGroup(void);

	void ExecuteAsync(void);

	void SetParameter(int nGroupID, const P_GT_BUDDY_GROUP_UPDATABLE_DATA &sInfo)
	{
		m_nGroupID = nGroupID;
		m_sGroupInfo = sInfo;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:

	int m_nGroupID;
	P_GT_BUDDY_GROUP_UPDATABLE_DATA m_sGroupInfo;
};
